// Generated from net_conf.json. Do not edit!
#ifndef CNI_NET_CONF_SCHEMA_H
#define CNI_NET_CONF_SCHEMA_H

#include <sys/types.h>
#include <stdint.h>
#include "json_common.h"
#include "cni_network_route.h"
#include "cni_network_dns.h"
#include "cni_net_args.h"
#include "cni_result_curr.h"
#include "cni_network_interface.h"
#include "cni_network_ipconfig.h"
#include "defs.h"
#include "cni_network_ipconfig_020.h"
#include "cni_inner_port_mapping.h"
#include "cni_bandwidth_entry.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
    char *type;

    char *subnet;

    char *gateway;

    char *range_start;

    char *range_end;

    cni_network_route **routes;
    size_t routes_len;

    yajl_val _residual;
}
cni_net_conf_ipam;

void free_cni_net_conf_ipam(cni_net_conf_ipam *ptr);

cni_net_conf_ipam *make_cni_net_conf_ipam(yajl_val tree, const struct parser_context *ctx, parser_error *err);

yajl_gen_status gen_cni_net_conf_ipam(yajl_gen g, const cni_net_conf_ipam *ptr, const struct parser_context *ctx, parser_error *err);

typedef struct {
    cni_inner_port_mapping **port_mappings;
    size_t port_mappings_len;

    cni_bandwidth_entry *bandwidth;

    yajl_val _residual;
}
cni_net_conf_runtime_config;

void free_cni_net_conf_runtime_config(cni_net_conf_runtime_config *ptr);

cni_net_conf_runtime_config *make_cni_net_conf_runtime_config(yajl_val tree, const struct parser_context *ctx, parser_error *err);

yajl_gen_status gen_cni_net_conf_runtime_config(yajl_gen g, const cni_net_conf_runtime_config *ptr, const struct parser_context *ctx, parser_error *err);

typedef struct {
    char *cni_version;

    char *name;

    char *type;

    bool ip_masq;

    cni_net_conf_ipam *ipam;

    cni_network_dns *dns;

    cni_net_args *args;

    cni_result_curr *prev_result;

    cni_net_conf_runtime_config *runtime_config;

    json_map_string_bool *capabilities;

    yajl_val _residual;
}
cni_net_conf;

void free_cni_net_conf(cni_net_conf *ptr);

cni_net_conf *make_cni_net_conf(yajl_val tree, const struct parser_context *ctx, parser_error *err);

yajl_gen_status gen_cni_net_conf(yajl_gen g, const cni_net_conf *ptr, const struct parser_context *ctx, parser_error *err);

cni_net_conf *cni_net_conf_parse_file(const char *filename, const struct parser_context *ctx, parser_error *err);

cni_net_conf *cni_net_conf_parse_file_stream(FILE *stream, const struct parser_context *ctx, parser_error *err);

cni_net_conf *cni_net_conf_parse_data(const char *jsondata, const struct parser_context *ctx, parser_error *err);

char *cni_net_conf_generate_json(const cni_net_conf *ptr, const struct parser_context *ctx, parser_error *err);

#ifdef __cplusplus
}
#endif

#endif

